module MeterpreterDetection_Timing;

function connection_established_helper(c: connection)
	{
	local ts = network_time();
	local trip = MeterpreterDetection::id_to_triplet(c$id);

	if ( trip in flagged )
		return;

	if ( trip !in nix_polling_data )
		nix_polling_data[trip] = [ ];
	local current_state = nix_polling_data[trip];

	next_step(current_state, ts);
	if ( longest(current_state) > threshold )
		{
		add flagged[trip];
		local message = fmt("Meterpreter detected with reason=TIMING_DETECTED, protocol=ANY, os=NIX");
		MeterpreterDetection::log_a_notice(c, message,
		    MeterpreterDetection::Meterpreter_Detected, T);
		}

	nix_polling_data[trip] = current_state;
	}

event connection_established(c: connection)
	{
	connection_established_helper(c);
	}

function connection_finished_helper(c: connection)
	{
	# Update last delay
	local ts = network_time();
	local trip = MeterpreterDetection::id_to_triplet(c$id);

	if ( trip in flagged )
		return;

	if ( trip !in nix_polling_data )
		nix_polling_data[trip] = [ ];
	local current_state = nix_polling_data[trip];

	current_state$last_delay = ts - current_state$last_timestamp;

	nix_polling_data[trip] = current_state;
	}

event connection_finished(c: connection)
	{
	connection_finished_helper(c);
	}
